﻿Imports System.Collections.ObjectModel
Imports C1.WPF.C1Chart

Class MainWindow

    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        Dim dt As New DateTime(2012, 12, 1)
        Dim xValueList As New ObservableCollection(Of DateTime)()
        For i As Integer = 0 To 25
            Dim tempDate As DateTime = dt.AddHours(i)
            xValueList.Add(tempDate)
        Next
        Dim valueList As New ObservableCollection(Of Double)()
        valueList.Add(20030)
        valueList.Add(52402)
        valueList.Add(40232)
        valueList.Add(21030)
        valueList.Add(10203)
        valueList.Add(92390)
        valueList.Add(20030)
        valueList.Add(89002)
        valueList.Add(30032)
        valueList.Add(45000)
        valueList.Add(60303)
        valueList.Add(73230)
        valueList.Add(30920)
        valueList.Add(23090)
        valueList.Add(20030)
        valueList.Add(23903)
        valueList.Add(20300)
        valueList.Add(10900)
        valueList.Add(73200)
        valueList.Add(90230)
        valueList.Add(21030)
        valueList.Add(45000)
        valueList.Add(39020)
        valueList.Add(16050)
        valueList.Add(20300)

        Dim ds As New XYDataSeries()
        ds.XValuesSource = xValueList
        ds.ValuesSource = valueList
        ds.ChartType = ChartType.Column
        c1Chart1.Data.Children.Add(ds)
        AddHandler ds.PlotElementLoaded, AddressOf ds_PlotElementLoaded

        c1Chart1.View.AxisX.IsTime = True
        c1Chart1.View.AxisX.AnnoFormat = "HH:mm"
        c1Chart1.View.AxisX.AnnoAngle = 315
        c1Chart1.View.AxisX.AutoMax = False
        c1Chart1.View.AxisX.AutoMin = False
        c1Chart1.View.AxisX.Min = dt.AddHours(0).ToOADate()
        c1Chart1.View.AxisX.Max = dt.AddHours(25).ToOADate()
        c1Chart1.View.AxisX.MajorUnit = 0.125

    End Sub

    Private startPlotElement As PlotElement
    Private endPlotElement As PlotElement
    Private selectionList As New List(Of PlotElement)()
    Private defaultColor As SolidColorBrush


    Sub ds_PlotElementLoaded(sender As Object, e As EventArgs)
        Dim ps As PlotElement = TryCast(sender, PlotElement)
        defaultColor = TryCast(ps.Fill, SolidColorBrush)
        AddHandler ps.MouseLeftButtonUp, AddressOf PlotElement_MouseLeftButtonUp

    End Sub

    Public Sub PlotElement_MouseLeftButtonUp(sender As Object, e As System.Windows.Input.MouseEventArgs)
        Dim ps As PlotElement = TryCast(sender, PlotElement)
        If Keyboard.Modifiers = ModifierKeys.Shift Then
            If startPlotElement Is Nothing Then
                startPlotElement = ps
            Else
                endPlotElement = ps
                ChartSelectionList()
            End If
        Else
            ClearSelectionList()
            startPlotElement = ps
            selectionList.Add(startPlotElement)
        End If
        ChartPointHighlight()
    End Sub

    Public Sub ChartSelectionList()
        If startPlotElement IsNot Nothing AndAlso endPlotElement IsNot Nothing Then
            Dim startIndex As Integer, endIndex As Integer
            If startPlotElement.DataPoint.PointIndex < endPlotElement.DataPoint.PointIndex Then
                startIndex = startPlotElement.DataPoint.PointIndex
                endIndex = endPlotElement.DataPoint.PointIndex
            Else
                startIndex = endPlotElement.DataPoint.PointIndex
                endIndex = startPlotElement.DataPoint.PointIndex
            End If


            Dim plotElementList As New List(Of Bar)
            For Each ps As UIElement In (CType(c1Chart1.Data.Children(0), XYDataSeries).Children)
                If ps.GetType() Is GetType(Bar) Then
                    plotElementList.Add(CType(ps, Bar))
                End If
            Next

            selectionList = New List(Of PlotElement)
            For Each ps As Bar In plotElementList
                If CType(ps, PlotElement).DataPoint.PointIndex >= startIndex And CType(ps, PlotElement).DataPoint.PointIndex <= endIndex Then
                    selectionList.Add(CType(ps, PlotElement))
                End If
            Next

        End If
    End Sub

    Public Sub ChartPointHighlight()
        For Each ps As PlotElement In selectionList
            ps.Fill = New SolidColorBrush(Colors.LightGreen)
            ps.LayoutTransform = New ScaleTransform()
        Next
    End Sub

    Public Sub ClearSelectionList()
        For Each ps As PlotElement In selectionList
            ps.Fill = defaultColor
            ps.LayoutTransform = New ScaleTransform()
            ps.UpdateLayout()
        Next
        If startPlotElement IsNot Nothing Then
            If startPlotElement.Tag <> Nothing Then
                startPlotElement.Fill = defaultColor
                startPlotElement.LayoutTransform = New ScaleTransform()
            End If
        End If
        startPlotElement = Nothing
        endPlotElement = Nothing
        selectionList.Clear()
    End Sub

End Class
